VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cMouseWheel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Compare Text
Option Explicit

Private frm As Object
Private intCancel As Integer

Public Event MouseWheel(ByRef Cancel As Integer, _
ByVal hWnd As Long, ByVal uMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long)

Public Event MouseMoving(ByVal hWnd As Long, ByVal uMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long)

Public Event Paint(ByVal hWnd As Long, ByVal uMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long)

Public Event HScroll(ByVal hWnd As Long, ByVal uMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long)

Public Event VScroll(ByVal hWnd As Long, ByVal uMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long)

Public Event WinMoving(ByVal hWnd As Long, ByVal uMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long)

Private lpPrevWndProc As Long

Public Property Set Form(frmIn As Object)
    Set frm = frmIn
End Property

Friend Property Get PrevWndProc() As Long
  PrevWndProc = lpPrevWndProc
End Property

Public Property Get MouseWheelCancel() As Integer
    MouseWheelCancel = intCancel
End Property

Public Sub SubClassHookForm()
    lpPrevWndProc = SetWindowLong(frm.hWnd, GWL_WNDPROC, _
                                    AddressOf WindowProc)
    Call AddCMouse(Me, frm.hWnd)
End Sub

Public Sub SubClassUnHookForm()
    Call SetWindowLong(frm.hWnd, GWL_WNDPROC, lpPrevWndProc)
    Call RemCMouse(frm.hWnd)
End Sub


Public Sub FireMouseWheel(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
    RaiseEvent MouseWheel(intCancel, hWnd, uMsg, wParam, lParam)
End Sub

Public Sub FireMouseMoving(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
    RaiseEvent MouseMoving(hWnd, uMsg, wParam, lParam)
End Sub

Public Sub FirePaint(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
    RaiseEvent Paint(hWnd, uMsg, wParam, lParam)
End Sub

Public Sub FireVScroll(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
    RaiseEvent VScroll(hWnd, uMsg, wParam, lParam)
End Sub

Public Sub FireHScroll(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
    RaiseEvent HScroll(hWnd, uMsg, wParam, lParam)
End Sub

Public Sub FireWinMoving(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
    RaiseEvent WinMoving(hWnd, uMsg, wParam, lParam)
End Sub

Private Sub Class_Terminate()
    Call RemCMouse(frm.hWnd)
End Sub
